; ##############################################################################
; ##############################################################################
; ##############################################################################
; BEGRUNG																		
ANZEIGE_BEGRUESSUNG:
	; ZEILE1	
	call ZEILE1
	ldi ZH, high(TEXT_BEGRUESSUNG_1*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_1*2)
	call ANZEIGE_TEXT_Z
	; ZEILE2	
	call ZEILE2
	ldi ZH, high(TEXT_BEGRUESSUNG_2*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_2*2)
	call ANZEIGE_TEXT_Z
	; ZEILE3		
	call ZEILE3
	ldi ZH, high(TEXT_BEGRUESSUNG_3*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_3*2)
	call ANZEIGE_TEXT_Z
	; ZEILE4		
	call ZEILE4
	ldi ZH, high(TEXT_BEGRUESSUNG_4*2)	; TEXT 
	ldi ZL,  low(TEXT_BEGRUESSUNG_4*2)
	call ANZEIGE_TEXT_Z
	call ASCII_SPACE
	call ASCII_V
	LDS temp1,(adr_VERSION)
	call ZAHL2_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_ERROR:
	call LCD_CLEAR
	call TEXT_ERROR
	call ASCII_M
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_ERROR_MODUL_NR)
	call HEX_TEMP1
	call ASCII_SPACE

	call ASCII_C
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_ERROR_CODE)
	call HEX_TEMP1

	call ZEILE2
	call TEXT_WARNUNG
	call ASCII_C
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_WARNUNG_CODE)
	call HEX_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_HILFE_LED1:
	call TEXT_LED
	call TEXT_ARP	

	call ZEILE2
	call TEXT_LED
	call TEXT_1WIRE

	call ZEILE3
	call TEXT_LED
	call TEXT_ENC
	call TEXT_RX
	call TEXT_TX

	call ZEILE4
	call TEXT_LED
	call TEXT_ONLINE

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_HILFE_LED2:
	call TEXT_LED
	call TEXT_ENC
	call TEXT_RESET

	call ZEILE2
	call TEXT_LED
	call TEXT_TX
	call TEXT_SERIELL

	call ZEILE3
	call TEXT_LED
	call ASCII_B
	call ASCII_SPACE
	call TEXT_PORT
	call ASCII_o_
	call ASCII_p_
	call ASCII_e_
	call ASCII_n_

	call ZEILE4
	call TEXT_LED
	call ASCII_C
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STATUS_ANGRIFFE:
	call TEXT_ANGRIFFE
	LDS temp1,(adr_FW_ANGRIFFE_L)
	LDS temp2,(adr_FW_ANGRIFFE_H)
	call ZAHL_TEMP1_2

	call ZEILE3
	LDS temp1,(adr_FW_PORT_DESTINATION_L)
	LDS temp2,(adr_FW_PORT_DESTINATION_H)
	call ZAHL_TEMP1_2

	call ZEILE4
	LDS temp1,(adr_FW_IP4SourceIPaddr3)
	LDS temp2,(adr_FW_IP4SourceIPaddr2)
	LDS temp3,(adr_FW_IP4SourceIPaddr1)
	LDS temp4,(adr_FW_IP4SourceIPaddr0)
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STATUS_FIREWALL:
	call TEXT_STATUS
	call TEXT_FIREWALL
	call ZEILE2
	LDS temp1,(adr_TCP_ANZAHL_AUFRUFE_L)
	LDS temp2,(adr_TCP_ANZAHL_AUFRUFE_H)
	call ZAHL_TEMP1_2
	call TEXT_AUFRUFE

	call ZEILE3
	LDS temp1,(adr_FW_ANGRIFFE_L)
	LDS temp2,(adr_FW_ANGRIFFE_H)
	call ZAHL_TEMP1_2
	call TEXT_ANGRIFFE

	call ZEILE4
	LDS temp1,(adr_FW_ANGRIFFE_NEU_L)
	LDS temp2,(adr_FW_ANGRIFFE_NEU_H)
	call ZAHL_TEMP1_2
	call ASCII_n_
	call ASCII_e_
	call ASCII_u_
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STATUS_WEBSERVER:
	call TEXT_STATUS
	call TEXT_WEBSERVER
	call ZEILE2
	call FUNCTION_MAC_EIGENE_NACH_TEMP1_6
	call ANZEIGE_MAC_ADRESSE_KURZ_temp1_6
	call ZEILE3
	call FUNCTION_IP_EIGENE_NACH_TEMP1_4
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
	call ZEILE4
	LDS temp1,(adr_TCP_PORT_WEB_A_L)
	LDS temp2,(adr_TCP_PORT_WEB_A_H)
	call ZAHL_TEMP1_2
	LDS temp1,(adr_TCP_PORT_WEB_B_L)
	LDS temp2,(adr_TCP_PORT_WEB_B_H)
	call ZAHL_TEMP1_2
	LDS temp1,(adr_TCP_PORT_WEB_C_L)
	LDS temp2,(adr_TCP_PORT_WEB_C_H)
	call ZAHL_TEMP1_2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STATUS_ROUTER:
	call TEXT_STATUS
	call TEXT_ROUTER
	call ZEILE2
	call FUNCTION_MAC_ROUTER_NACH_TEMP1_6
	call ANZEIGE_MAC_ADRESSE_KURZ_temp1_6
	call ZEILE3
	call FUNCTION_IP_ROUTER_NACH_TEMP1_4
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
	call ZEILE4
	call FUNCTION_IP_OFFENTLICH_NACH_TEMP1_4
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Protokollaufbau (MAC-HEADER 14Bytes)											
ANZEIGE_STATUS_MAC_HEADER:
	call TEXT_STATUS
	call TEXT_MAC
	call TEXT_HEADER
	; ZEILE2	
	call ZEILE2
	LDS temp1,(SourceMACaddr0)			
	LDS temp2,(SourceMACaddr1)		
	LDS temp3,(SourceMACaddr2)			
	LDS temp4,(SourceMACaddr3)			
	LDS temp5,(SourceMACaddr4)			
	LDS temp6,(SourceMACaddr5)			
	call ANZEIGE_MAC_ADRESSE_KURZ_temp1_6
	; ZEILE3		
	call ZEILE3
	LDS temp1,(DestinationMACaddr0)
	LDS temp2,(DestinationMACaddr1)	
	LDS temp3,(DestinationMACaddr2)	
	LDS temp4,(DestinationMACaddr3)	
	LDS temp5,(DestinationMACaddr4)	
	LDS temp6,(DestinationMACaddr5)	
	call ANZEIGE_MAC_ADRESSE_KURZ_temp1_6
	; ZEILE4		
	call ZEILE4
	LDS temp2,(MacPacketTypH)
	LDS temp1,(MacPacketTypL)				
	call HEX_TEMP1_2
	call ASCII_SPACE
	call ANZEIGE_MAC_PAKET_TYP_KURZ
	call ASCII_SPACE
;-------------------------------------------------------------------------------
	LDS temp1,(MacPacketTypL)				
	LDS temp2,(MacPacketTypH)
	cpi temp1,low (MAC_PAKET_TYP_IPV4)
	brne ANZEIGE_STATUS_MAC_HEADER_NO_IPv4
	cpi temp2,high(MAC_PAKET_TYP_IPV4)
	brne ANZEIGE_STATUS_MAC_HEADER_NO_IPv4
	jmp ANZEIGE_IPv4_PROTOKOLL_TYP_KURZ
ANZEIGE_STATUS_MAC_HEADER_NO_IPv4:
	jmp ASCII_SPACE6
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STATUS_IPv4:
	call TEXT_STATUS
	call TEXT_IPV4

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STATUS_TCP_RX:
	call TEXT_STATUS
	call TEXT_TCP
;-------------------------------------------------------------------------------
	call ZEILE2_CLEAR
	LDS temp1,(adr_TCP_RX_VIEW_TCP_FLAGS)
	call ANZEIGE_TCP_FLAGS_TEXT_TEMP1
;-------------------------------------------------------------------------------
	call ZEILE3
	LDS temp1,(adr_TCP_RX_VIEW_TCP_PORT_DEST_L)
	LDS temp2,(adr_TCP_RX_VIEW_TCP_PORT_DEST_H)
	call ZAHL_TEMP1_2
;-------------------------------------------------------------------------------
	call ZEILE4
	LDS temp1,(adr_TCP_RX_VIEW_IP4SourceIPaddr0)
	LDS temp2,(adr_TCP_RX_VIEW_IP4SourceIPaddr1)
	LDS temp3,(adr_TCP_RX_VIEW_IP4SourceIPaddr2)
	LDS temp4,(adr_TCP_RX_VIEW_IP4SourceIPaddr3)
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4

	call WAIT_500ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STATUS_ARP:
	call TEXT_STATUS
	call TEXT_ARP
	call ZEILE2
	call TEXT_ARP
	call ASCII_DOPPEL_PUNKT
	call ASCII_SPACE
	LDS temp1,(adr_ARP_CHACHE_ANZAHL)
	call ZAHL_TEMP1
	call ZEILE3
	call TEXT_SCAN
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_ARP_SCAN_NR)
	call ZAHL_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STATUS_ENC:
	call TEXT_STATUS
	call TEXT_ENC
;-------------------------------------------------------------------------------
	call ZEILE2
	call ASCII_R
	call ASCII_X
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_ENC_RX_PAKET_COUNTER_ALLE_L)
	LDS temp2,(adr_ENC_RX_PAKET_COUNTER_ALLE_H)
	call ZAHL_TEMP1_2
;-------------------------------------------------------------------------------
	call ZEILE3
	call ASCII_T
	call ASCII_X
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_ENC_TX_PAKET_COUNTER_L)
	LDS temp2,(adr_ENC_TX_PAKET_COUNTER_H)
	call ZAHL_TEMP1_2
	call ASCII_E
	LDS temp1,(adr_ENC_TX_PAKET_COUNTER_ERROR_L)
	LDS temp2,(adr_ENC_TX_PAKET_COUNTER_ERROR_H)
	call ZAHL_TEMP1_2
;-------------------------------------------------------------------------------
	call ZEILE4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STATUS_SYSTEM:
	call TEXT_STATUS
	call TEXT_SYSTEM
;-------------------------------------------------------------------------------
	call ZEILE2
	call ASCII_S
	call ASCII_T
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_ANZAHL_START_L)
	LDS temp2,(adr_ANZAHL_START_H)
	call ZAHL_TEMP1_2
	call ASCII_Z
	call ASCII_Z
	call ZUFALLSZAHL_TEMP1
	call ZAHL_TEMP1
;-------------------------------------------------------------------------------
	call ZEILE3
	call ANZEIGE_DATUM_KURZ
	call ASCII_SPACE
	call ASCII_V
	ldi ZL,LOW (0)	; Z=EEPROM-ADRESSE	
	ldi ZH,HIGH(0)
	call EEPROM_READ_Z_PLUS_TEMP		; read		
	mov  temp1,temp
	call ZAHL_TEMP1
;-------------------------------------------------------------------------------
	call ZEILE4
	call ANZEIGE_BETRIEBSSTUNDEN_KURZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; HTML																			
ANZEIGE_STATUS_HTML:
	call TEXT_STATUS
	call TEXT_HTML
;-------------------------------------------------------------------------------
	call ZEILE2
	call TEXT_HTML
	call ASCII_C
	call ASCII_L
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_HTML_CONTENENT_LENGTH_L)
	LDS temp2,(adr_HTML_CONTENENT_LENGTH_H)
	call ZAHL_TEMP1_2
;-------------------------------------------------------------------------------
	call ZEILE3
	call TEXT_HTML
	call ASCII_D
	call ASCII_L
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_HTML_DATA_LENGTH_L)
	LDS temp2,(adr_HTML_DATA_LENGTH_H)
	call ZAHL_TEMP1_2
;-------------------------------------------------------------------------------
	call ZEILE4
	call ASCII_P
	call ASCII_C
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_TCP_PAKET_COUNTER)
	call ZAHL_temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1-WIRE																		
ANZEIGE_STATUS_1WIRE:
	call TEXT_STATUS
	call TEXT_1WIRE
;---------------------------------------------------------------------------
	call ZEILE2
	call ASCII_R
	call ASCII_X
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_1WIRE_COUNTER_L)
	LDS temp2,(adr_1WIRE_COUNTER_H)
	call ZAHL_TEMP1_2
	call ASCII_E
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_1WIRE_PS_ERROR_L)
	LDS temp2,(adr_1WIRE_PS_ERROR_H)
	call ZAHL_TEMP1_2
;---------------------------------------------------------------------------
	call ZEILE3
	call ASCII_P
	call ASCII_S
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_1WIRE_PS_EMPFANGEN)	; Prfsumme
	call HEX_TEMP1
	call ASCII_SPACE
	LDS temp1,(adr_1WIRE_PS_BERECHNET)				; Prfsumme
	call HEX_TEMP1
;---------------------------------------------------------------------------
	call ZEILE4
	call ASCII_R
	call ASCII_P
	call ASCII_R
	call ASCII_E
	call ASCII_DOPPEL_PUNKT
	LDS temp1,(adr_OW_ZAEHLER_RP_L)
	LDS temp2,(adr_OW_ZAEHLER_RP_H)
	call ZAHL_TEMP1_2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TCPflag_FIN	= 0																
; TCPflag_SYN	= 1																
; TCPflag_RESET	= 2																
; TCPflag_PUSH	= 3																
; TCPflag_ACK	= 4																
; TCPflag_URG	= 5																
; TCPflag_ECN	= 6																
; TCPflag_WCR	= 7																
ANZEIGE_TCP_FLAGS_TEXT_TEMP1:
	SBRC temp1,TCPflag_FIN
	call TEXT_FIN

	SBRC temp1,TCPflag_SYN
	call TEXT_SYN

	SBRC temp1,TCPflag_RESET
	call TEXT_RESET

	SBRC temp1,TCPflag_PUSH
	call TEXT_PUSH

	SBRC temp1,TCPflag_ACK
	call TEXT_ACK

	SBRC temp1,TCPflag_URG
	call TEXT_URG

	SBRC temp1,TCPflag_ECN
	call TEXT_ECN

	SBRC temp1,TCPflag_WCR
	call TEXT_WCR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_TCP_FLAGS_TEMP1:
	SBRC temp1,TCPflag_FIN
	call ASCII_F
	SBRC temp1,TCPflag_SYN
	call ASCII_S
	SBRC temp1,TCPflag_RESET
	call ASCII_R
	SBRC temp1,TCPflag_PUSH
	call ASCII_P
	SBRC temp1,TCPflag_URG
	call ASCII_U
	SBRC temp1,TCPflag_ECN
	call ASCII_E
	SBRC temp1,TCPflag_WCR
	call ASCII_W
	SBRC temp1,TCPflag_ACK
	call ASCII_A
	call ASCII_SPACE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ANZEIGE_STATUS_USART_RS232:
	call TEXT_STATUS
	call TEXT_RS232
	call ZEILE2
	ldi temp1,low (9600)
	ldi temp2,high(9600)
	call ZAHL_TEMP1_2
	call ASCII_B
	call ASCII_d
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EDIT_IP_TEMP1_2_3_4:
	call BEEP_LANG
	STS(adr_DUMMY0),temp1
	STS(adr_DUMMY1),temp2
	STS(adr_DUMMY2),temp3
	STS(adr_DUMMY3),temp4
;---------------------------------------------------------------------------
EDIT_IP_w1:
	call TASTEN_ABFRAGE
	LDS temp1,(adr_DUMMY0)
	call TASTE_PLUS_MINUS_TEMP1			; Taste "+/-"	
	STS(adr_DUMMY0),temp1
	call EDIT_IP_ANZ
	call ZEILE4_CLEAR
	call ASCII_VOLL3
	call TASTE_MENUE_PLUS_C				; Menue "+"		
	brcs EDIT_IP_w2
	rjmp EDIT_IP_w1
;---------------------------------------------------------------------------
EDIT_IP_w2:
	call TASTEN_ABFRAGE
	LDS temp1,(adr_DUMMY1)
	call TASTE_PLUS_MINUS_TEMP1			; Taste "+/-"	
	STS(adr_DUMMY1),temp1
	call EDIT_IP_ANZ
	call ZEILE4_CLEAR
	call ASCII_SPACE4
	call ASCII_VOLL3
	call TASTE_MENUE_PLUS_C				; Menue "+"		
	brcs EDIT_IP_w3
	rjmp EDIT_IP_w2
;---------------------------------------------------------------------------
EDIT_IP_w3:
	call TASTEN_ABFRAGE
	LDS temp1,(adr_DUMMY2)
	call TASTE_PLUS_MINUS_TEMP1			; Taste "+/-"	
	STS(adr_DUMMY2),temp1
	call EDIT_IP_ANZ
	call ZEILE4_CLEAR
	call ASCII_SPACE4
	call ASCII_SPACE4
	call ASCII_VOLL3
	call TASTE_MENUE_PLUS_C				; Menue "+"		
	brcs EDIT_IP_w4
	rjmp EDIT_IP_w3
;---------------------------------------------------------------------------
EDIT_IP_w4:
	call TASTEN_ABFRAGE
	LDS temp1,(adr_DUMMY3)
	call TASTE_PLUS_MINUS_TEMP1			; Taste "+/-"	
	STS(adr_DUMMY3),temp1
	call EDIT_IP_ANZ
	call ZEILE4_CLEAR
	call ASCII_SPACE4
	call ASCII_SPACE4
	call ASCII_SPACE4
	call ASCII_VOLL3
	call TASTE_MENUE_PLUS_C				; Menue "+"		
	brcs EDIT_IP_EXIT
	rjmp EDIT_IP_w4
;---------------------------------------------------------------------------
EDIT_IP_EXIT:
	LDS temp1,(adr_DUMMY0)
	LDS temp2,(adr_DUMMY1)
	LDS temp3,(adr_DUMMY2)
	LDS temp4,(adr_DUMMY3)
	call BEEP_LANG
	call LCD_CLEAR
ret
;---------------------------------------------------------------------------
EDIT_IP_ANZ:
	call ZEILE3
	LDS temp1,(adr_DUMMY0)
	LDS temp2,(adr_DUMMY1)
	LDS temp3,(adr_DUMMY2)
	LDS temp4,(adr_DUMMY3)
	call ANZEIGE_IP_ADRESSE_KURZ_temp1_4
	call TASTEN_WAIT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

