.equ LOGBUCH_MAX_ANZAHL			= 40
.equ LOGBUCH_DATA_LENGTH		= 11
.equ LOGBUCH_TAG				= adr_LOGBUCH_DATA+0
.equ LOGBUCH_MONAT				= adr_LOGBUCH_DATA+1
.equ LOGBUCH_hh					= adr_LOGBUCH_DATA+2
.equ LOGBUCH_mm					= adr_LOGBUCH_DATA+3
.equ LOGBUCH_IPsource0			= adr_LOGBUCH_DATA+4
.equ LOGBUCH_IPsource1			= adr_LOGBUCH_DATA+5
.equ LOGBUCH_IPsource2			= adr_LOGBUCH_DATA+6
.equ LOGBUCH_IPsource3			= adr_LOGBUCH_DATA+7
.equ LOGBUCH_PORT_DEST_L		= adr_LOGBUCH_DATA+8
.equ LOGBUCH_PORT_DEST_H		= adr_LOGBUCH_DATA+9
.equ LOGBUCH_ANZAHL				= adr_LOGBUCH_DATA+10
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOGBUCH_EINTRAG:
	LDS temp, (adr_TAG)							;
	LDS temp1,(LOGBUCH_TAG)
	cp temp,temp1
	brne LOGBUCH_EINTRAG_RUN
	LDS temp, (adr_MONAT)						;
	LDS temp1,(LOGBUCH_MONAT)
	cp temp,temp1
	brne LOGBUCH_EINTRAG_RUN
	LDS temp ,(adr_TCP_RX_VIEW_IP4SourceIPaddr0)	;
	LDS temp1,(LOGBUCH_IPsource0)
	cp temp,temp1
	brne LOGBUCH_EINTRAG_RUN
	LDS temp ,(adr_TCP_RX_VIEW_IP4SourceIPaddr1)	;
	LDS temp1,(LOGBUCH_IPsource1)
	cp temp,temp1
	brne LOGBUCH_EINTRAG_RUN
	LDS temp ,(adr_TCP_RX_VIEW_IP4SourceIPaddr2)	;
	LDS temp1,(LOGBUCH_IPsource2)
	cp temp,temp1
	brne LOGBUCH_EINTRAG_RUN
	LDS temp ,(adr_TCP_RX_VIEW_IP4SourceIPaddr3)	;
	LDS temp1,(LOGBUCH_IPsource3)
	cp temp,temp1
	brne LOGBUCH_EINTRAG_RUN
	LDS temp, (adr_TCP_RX_VIEW_TCP_PORT_DEST_L)	;
	LDS temp1,(LOGBUCH_PORT_DEST_L)
	cp temp,temp1
	brne LOGBUCH_EINTRAG_RUN
	LDS temp, (adr_TCP_RX_VIEW_TCP_PORT_DEST_H)	;
	LDS temp1,(LOGBUCH_PORT_DEST_H)
	cp temp,temp1
	brne LOGBUCH_EINTRAG_RUN
	; ANZAHL+1				
	LDS temp,(LOGBUCH_ANZAHL)
	inc temp
	tst temp
	brne LOGBUCH_EINTRAG_w
	ret
LOGBUCH_EINTRAG_w:
	STS(LOGBUCH_ANZAHL),temp
	ret
;-------------------------------------------------------------------------------
LOGBUCH_EINTRAG_RUN:
	call LOGBUCH_SCHIEBEN
	call LOGBUCH_EINTRAG_WRITE_NEW
	ret
;-------------------------------------------------------------------------------
LOGBUCH_EINTRAG_WRITE_NEW:
	LDS temp,(adr_TAG)
	STS(LOGBUCH_TAG),temp
	LDS temp,(adr_MONAT)
	STS(LOGBUCH_MONAT),temp

	LDS temp,(adr_hh)
	STS(LOGBUCH_hh),temp
	LDS temp,(adr_mm)
	STS(LOGBUCH_mm),temp

	LDS temp,(adr_TCP_RX_VIEW_IP4SourceIPaddr0)
	STS(LOGBUCH_IPsource0),temp
	LDS temp,(adr_TCP_RX_VIEW_IP4SourceIPaddr1)
	STS(LOGBUCH_IPsource1),temp
	LDS temp,(adr_TCP_RX_VIEW_IP4SourceIPaddr2)
	STS(LOGBUCH_IPsource2),temp
	LDS temp,(adr_TCP_RX_VIEW_IP4SourceIPaddr3)
	STS(LOGBUCH_IPsource3),temp

	LDS temp,(adr_TCP_RX_VIEW_TCP_PORT_DEST_L)
	STS(LOGBUCH_PORT_DEST_L),temp
	LDS temp,(adr_TCP_RX_VIEW_TCP_PORT_DEST_H)
	STS(LOGBUCH_PORT_DEST_H),temp

	STS(LOGBUCH_ANZAHL),EINS
ret
;-------------------------------------------------------------------------------
LOGBUCH_SCHIEBEN:
	ldi ZL,LOW (adr_LOGBUCH_DATA+(LOGBUCH_MAX_ANZAHL)*(LOGBUCH_DATA_LENGTH)-1)
	ldi ZH,HIGH(adr_LOGBUCH_DATA+(LOGBUCH_MAX_ANZAHL)*(LOGBUCH_DATA_LENGTH)-1)
	mov YL,ZL
	MOV YH,ZH
	adiw YL,(LOGBUCH_DATA_LENGTH)
LOGBUCH_SCHIEBEN_s:
	LD temp,Z
	ST Y,temp
	sbiw ZL,1
	sbiw YL,1
	cpi ZL,LOW (adr_LOGBUCH_DATA-1)
	brne LOGBUCH_SCHIEBEN_s
	cpi ZH,HIGH(adr_LOGBUCH_DATA-1)
	brne LOGBUCH_SCHIEBEN_s
ret
