; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_MAC_EIGENE_NACH_TEMP1_6:
	LDS temp1,(adr_MAC0)
	LDS temp2,(adr_MAC1)
	LDS temp3,(adr_MAC2)
	LDS temp4,(adr_MAC3)
	LDS temp5,(adr_MAC4)
	LDS temp6,(adr_MAC5)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_MAC_ROUTER_NACH_TEMP1_6:
	LDS temp1,(adr_MAC_ROUTER0)
	LDS temp2,(adr_MAC_ROUTER1)
	LDS temp3,(adr_MAC_ROUTER2)
	LDS temp4,(adr_MAC_ROUTER3)
	LDS temp5,(adr_MAC_ROUTER4)
	LDS temp6,(adr_MAC_ROUTER5)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_IP_EIGENE_NACH_TEMP1_4:
	LDS temp1,(adr_IP_EIGENE0)
	LDS temp2,(adr_IP_EIGENE1)
	LDS temp3,(adr_IP_EIGENE2)
	LDS temp4,(adr_IP_EIGENE3)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_IP_ROUTER_NACH_TEMP1_4:
	LDS temp1,(adr_IP_ROUTER0)
	LDS temp2,(adr_IP_ROUTER1)
	LDS temp3,(adr_IP_ROUTER2)
	LDS temp4,(adr_IP_ROUTER3)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_IP_OFFENTLICH_NULL:
	STS(adr_IP_OFFENTLICH0),NULL
	STS(adr_IP_OFFENTLICH1),NULL
	STS(adr_IP_OFFENTLICH2),NULL
	STS(adr_IP_OFFENTLICH3),NULL
ret
; ##############################################################################
FUNCTION_IP_OFFENTLICH_NACH_TEMP1_4:
	LDS temp1,(adr_IP_OFFENTLICH0)
	LDS temp2,(adr_IP_OFFENTLICH1)
	LDS temp3,(adr_IP_OFFENTLICH2)
	LDS temp4,(adr_IP_OFFENTLICH3)
ret
; ##############################################################################
; IP=0.0.0.0 ---> C=1															
FUNCTION_IP_OFFENTLICH_NULL_CHECK_C:
	LDS temp,(adr_IP_OFFENTLICH0)
	tst temp
	brne FUNCTION_IP_OFFENTLICH_NO_NULL
	LDS temp,(adr_IP_OFFENTLICH1)
	tst temp
	brne FUNCTION_IP_OFFENTLICH_NO_NULL
	LDS temp,(adr_IP_OFFENTLICH2)
	tst temp
	brne FUNCTION_IP_OFFENTLICH_NO_NULL
	LDS temp,(adr_IP_OFFENTLICH3)
	tst temp
	brne FUNCTION_IP_OFFENTLICH_NO_NULL
;-------------------------------------------------------------------------------
	SEC 	;Set Carry		
	ret
;-------------------------------------------------------------------------------
FUNCTION_IP_OFFENTLICH_NO_NULL:
	CLC 	;Clear Carry	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_IP_SERVER_EXTERN_NULL:
	STS(adr_IP_SERVER_EXTERN0),NULL
	STS(adr_IP_SERVER_EXTERN1),NULL
	STS(adr_IP_SERVER_EXTERN2),NULL
	STS(adr_IP_SERVER_EXTERN3),NULL
ret
; ##############################################################################
FUNCTION_IP_SERVER_EXTERN_NACH_TEMP1_4:
	LDS temp1,(adr_IP_SERVER_EXTERN0)
	LDS temp2,(adr_IP_SERVER_EXTERN1)
	LDS temp3,(adr_IP_SERVER_EXTERN2)
	LDS temp4,(adr_IP_SERVER_EXTERN3)
ret
; ##############################################################################
; IP=0.0.0.0 ---> C=1															
FUNCTION_IP_SERVER_EXTERN_NULL_CHECK_C:
	LDS temp,(adr_IP_SERVER_EXTERN0)
	tst temp
	brne FUNCTION_IP_SERVER_EXTERN_NO_NULL
	LDS temp,(adr_IP_SERVER_EXTERN1)
	tst temp
	brne FUNCTION_IP_SERVER_EXTERN_NO_NULL
	LDS temp,(adr_IP_SERVER_EXTERN2)
	tst temp
	brne FUNCTION_IP_SERVER_EXTERN_NO_NULL
	LDS temp,(adr_IP_SERVER_EXTERN3)
	tst temp
	brne FUNCTION_IP_SERVER_EXTERN_NO_NULL
;-------------------------------------------------------------------------------
	SEC 	;Set Carry		
	ret
;-------------------------------------------------------------------------------
FUNCTION_IP_SERVER_EXTERN_NO_NULL:
	CLC 	;Clear Carry	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
MAKE_MAC_HEADER_ROUTER_TYP_DOD:
	call FUNCTION_MAC_ROUTER_NACH_TEMP1_6
	STS(DestinationMACaddr0),temp1
	STS(DestinationMACaddr1),temp2
	STS(DestinationMACaddr2),temp3
	STS(DestinationMACaddr3),temp4
	STS(DestinationMACaddr4),temp5
	STS(DestinationMACaddr5),temp6
;-------------------------------------------------------------------------------
	call FUNCTION_MAC_EIGENE_NACH_TEMP1_6
	STS(SourceMACaddr0),temp1
	STS(SourceMACaddr1),temp2
	STS(SourceMACaddr2),temp3
	STS(SourceMACaddr3),temp4
	STS(SourceMACaddr4),temp5
	STS(SourceMACaddr5),temp6
;-------------------------------------------------------------------------------
	ldi temp2,high(MAC_PAKET_TYP_IPV4)
	ldi temp1,low (MAC_PAKET_TYP_IPV4)
	STS(MacPacketTypH),temp2
	STS(MacPacketTypL),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SourceMACaddr --> DestinationMACaddr											
; eigene MAC	--> SourceMACaddr												
MAKE_MAC_NEW_HEADER:
	LDS temp1,(SourceMACaddr0)		; Source-MAC-addr		
	LDS temp2,(SourceMACaddr1)
	LDS temp3,(SourceMACaddr2)
	LDS temp4,(SourceMACaddr3)
	LDS temp5,(SourceMACaddr4)
	LDS temp6,(SourceMACaddr5)
	STS(DestinationMACaddr0),temp1	; Destination-MAC-addr	
	STS(DestinationMACaddr1),temp2
	STS(DestinationMACaddr2),temp3
	STS(DestinationMACaddr3),temp4
	STS(DestinationMACaddr4),temp5
	STS(DestinationMACaddr5),temp6
	LDS temp1,(adr_MAC0)			; MAC-eigene			
	LDS temp2,(adr_MAC1)
	LDS temp3,(adr_MAC2)
	LDS temp4,(adr_MAC3)
	LDS temp5,(adr_MAC4)
	LDS temp6,(adr_MAC5)
	STS(SourceMACaddr0),temp1		; Source-MAC-addr		
	STS(SourceMACaddr1),temp2
	STS(SourceMACaddr2),temp3
	STS(SourceMACaddr3),temp4
	STS(SourceMACaddr4),temp5
	STS(SourceMACaddr5),temp6
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MAKE_MAC_TAUSCH_MAC:
	LDS temp1,(DestinationMACaddr0)
	LDS temp2,(DestinationMACaddr1)
	LDS temp3,(DestinationMACaddr2)
	LDS temp4,(DestinationMACaddr3)
	LDS temp5,(DestinationMACaddr4)
	LDS temp6,(DestinationMACaddr5)
	STS(adr_DUMMY0),temp1
	STS(adr_DUMMY1),temp2
	STS(adr_DUMMY2),temp3
	STS(adr_DUMMY3),temp4
	STS(adr_DUMMY4),temp5
	STS(adr_DUMMY5),temp6

	LDS temp1,(SourceMACaddr0)
	LDS temp2,(SourceMACaddr1)
	LDS temp3,(SourceMACaddr2)
	LDS temp4,(SourceMACaddr3)
	LDS temp5,(SourceMACaddr4)
	LDS temp6,(SourceMACaddr5)
	STS(DestinationMACaddr0),temp1
	STS(DestinationMACaddr1),temp2
	STS(DestinationMACaddr2),temp3
	STS(DestinationMACaddr3),temp4
	STS(DestinationMACaddr4),temp5
	STS(DestinationMACaddr5),temp6

	LDS temp1,(adr_DUMMY0)
	LDS temp2,(adr_DUMMY1)
	LDS temp3,(adr_DUMMY2)
	LDS temp4,(adr_DUMMY3)
	LDS temp5,(adr_DUMMY4)
	LDS temp6,(adr_DUMMY5)
	STS(SourceMACaddr0),temp1
	STS(SourceMACaddr1),temp2
	STS(SourceMACaddr2),temp3
	STS(SourceMACaddr3),temp4
	STS(SourceMACaddr4),temp5
	STS(SourceMACaddr5),temp6
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; IP4SourceIPaddr0 <-->IP4DestinationIPaddr										
MAKE_IP4_TAUSCH_IP:
	LDS temp1,(IP4SourceIPaddr3)
	LDS temp2,(IP4SourceIPaddr2)
	LDS temp3,(IP4SourceIPaddr1)
	LDS temp4,(IP4SourceIPaddr0)
	LDS temp5,(IP4DestinationIPaddr3)
	LDS temp6,(IP4DestinationIPaddr2)
	LDS temp7,(IP4DestinationIPaddr1)
	LDS temp8,(IP4DestinationIPaddr0)
	STS(IP4DestinationIPaddr3),temp1
	STS(IP4DestinationIPaddr2),temp2
	STS(IP4DestinationIPaddr1),temp3
	STS(IP4DestinationIPaddr0),temp4
	STS(IP4SourceIPaddr3),temp5
	STS(IP4SourceIPaddr2),temp6
	STS(IP4SourceIPaddr1),temp7
	STS(IP4SourceIPaddr0),temp8
ret
; ##############################################################################
MAKE_IP4_IP_EIGENE_NACH_IP4SourceIP:
	call FUNCTION_IP_EIGENE_NACH_TEMP1_4
	STS(IP4SourceIPaddr3),temp1
	STS(IP4SourceIPaddr2),temp2
	STS(IP4SourceIPaddr1),temp3
	STS(IP4SourceIPaddr0),temp4
ret
; ##############################################################################
MAKE_IP4_IP_ROUTER_NACH_IP4DestinationIP:
	call FUNCTION_IP_ROUTER_NACH_TEMP1_4
	STS(IP4DestinationIPaddr3),temp1
	STS(IP4DestinationIPaddr2),temp2
	STS(IP4DestinationIPaddr1),temp3
	STS(IP4DestinationIPaddr0),temp4
ret
; ##############################################################################
MAKE_IP4_VersionHeaderLength45:
	ldi temp,0x45
	STS(IP4VersionHeaderLength),temp;Version(4) Header Length(20Bytes)
ret
; ##############################################################################
MAKE_IP4_TOS_NULL:
	STS(IP4TOS),NULL
ret
; ##############################################################################
MAKE_IP4_IDENTIFIKATION:
;	call ZUFALLSZAHL_TEMP1
	ldi temp1,22
	STS(IP4IdentificationH),temp1
	STS(IP4IdentificationL),temp1
ret
; ##############################################################################
MAKE_IP4_FlagsFragmentOffset_NULL:
	STS(IP4FlagsFragmentOffset0),NULL
	STS(IP4FlagsFragmentOffset1),NULL
ret
; ##############################################################################
MAKE_IP4_FlagsFragmentOffset_Dont_Fragment:
	ldi temp,0x40			
	STS(IP4FlagsFragmentOffset0),temp;Flags: 0x02 (Don't Fragment)
	ldi temp,0x00
	STS(IP4FlagsFragmentOffset1),temp
ret
; ##############################################################################
MAKE_IP4_TimeToLive:
	ldi temp,128
	STS(IP4TimeToLive),temp			;Time to live: 128
ret
; ##############################################################################
MAKE_IP4_PROTOKOLL_TYP_TCP:
	ldi temp,(IPv4_PROTOKOLL_TYP_TCP)
	STS(IP4ProtocolTyp),temp
ret
; ##############################################################################
MAKE_IP4_PROTOKOLL_TYP_UDP:
	ldi temp,(IPv4_PROTOKOLL_TYP_UDP)
	STS(IP4ProtocolTyp),temp
ret
; ##############################################################################
MAKE_IP4_TOTAL_LENGTH_40BYTES:
	ldi ZL,LOW (40)							; 40=20(IPv4-Header)+20(TCP-Header)
	ldi ZH,HIGH(40)
	STS(IP4TotalLengthL),ZL
	STS(IP4TotalLengthH),ZH
ret
; ##############################################################################
MAKE_IP4_TOTAL_LENGTH_44BYTES:
	ldi ZL,LOW (44)							; 44=20(IPv4-Header)+24(TCP-Header)
	ldi ZH,HIGH(44)
	STS(IP4TotalLengthL),ZL
	STS(IP4TotalLengthH),ZH
ret
; ##############################################################################
MAKE_IP4_TOTAL_LENGTH_48BYTES:
	ldi ZL,LOW (48)							; 48=20(IPv4-Header)+28(TCP-Header)
	ldi ZH,HIGH(48)
	STS(IP4TotalLengthL),ZL
	STS(IP4TotalLengthH),ZH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
MAKE_TCP_TAUSCH_HEADER:
	; sourcePort<-->destinationPort
	LDS temp1,(TCPsourcePortL)
	LDS temp2,(TCPsourcePortH)
	LDS temp3,(TCPdestinationPortL)
	LDS temp4,(TCPdestinationPortH)
	STS(TCPdestinationPortL),temp1
	STS(TCPdestinationPortH),temp2
	STS(TCPsourcePortL),temp3
	STS(TCPsourcePortH),temp4
	; Windows Size					
	ldi temp1,LOW (1000)
	ldi temp2,HIGH(1000)
	STS(TCPwindowSizeL),temp1
	STS(TCPwindowSizeH),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; sourcePort<-->destinationPort													
MAKE_TCP_TAUSCH_PORT:
	LDS temp1,(TCPsourcePortL)
	LDS temp2,(TCPsourcePortH)
	LDS temp3,(TCPdestinationPortL)
	LDS temp4,(TCPdestinationPortH)
	STS(TCPdestinationPortL),temp1
	STS(TCPdestinationPortH),temp2
	STS(TCPsourcePortL),temp3
	STS(TCPsourcePortH),temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ACK=SEQ+1																		
; TcpSeq <---> TcpAck (TcpAck+1)												
MAKE_TCP_TAUSCH_SEQ_ACK_PLUS:
	LDS temp4,(TcpSeq3)	; SEQ		
	LDS temp3,(TcpSeq2)
	LDS temp2,(TcpSeq1)
	LDS temp1,(TcpSeq0)

	add temp1,EINS		; SEQ+1		
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL

	LDS temp8,(TcpAck3)	; ACK		
	LDS temp7,(TcpAck2)
	LDS temp6,(TcpAck1)
	LDS temp5,(TcpAck0)

	STS(TcpSeq3),temp8	; ACK-->SEQ	
	STS(TcpSeq2),temp7
	STS(TcpSeq1),temp6
	STS(TcpSeq0),temp5

	STS(TcpAck3),temp4	; SEQ-->ACK	
	STS(TcpAck2),temp3
	STS(TcpAck1),temp2
	STS(TcpAck0),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MAKE_TCP_HEADER_LENGTH_20BYTES:
	ldi temp,0x50				; 0x50=5x32:8=20Byte	
	STS(TCPHeaderLength),temp
ret
; ##############################################################################
MAKE_TCP_HEADER_LENGTH_24BYTES:
	ldi temp,0x60				; 0x60=6x32:8=24Byte	
	STS(TCPHeaderLength),temp
ret
; ##############################################################################
MAKE_TCP_HEADER_LENGTH_28BYTES:
	ldi temp,0x70				; 0x70=7x32:8=28Byte	
	STS(TCPHeaderLength),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MAKE_TCP_FLAG_ACK:
	ldi temp,(1<<TCPflag_ACK)
	STS(TCPflags),temp
ret
; ##############################################################################
MAKE_TCP_FLAG_PUSH_ACK:
	ldi temp,(1<<TCPflag_PUSH)|(1<<TCPflag_ACK)
	STS(TCPflags),temp
ret
; ##############################################################################
MAKE_TCP_FLAG_SYN:
	ldi temp,(1<<TCPflag_SYN)
	STS(TCPflags),temp
ret
; ##############################################################################
MAKE_TCP_FLAG_SYN_ACK:
	ldi temp,(1<<TCPflag_SYN)|(1<<TCPflag_ACK)	; FLAGS setzen		
	STS(TCPflags),temp
ret
; ##############################################################################
MAKE_TCP_FLAG_FIN:
	ldi temp,(1<<TCPflag_FIN)
	STS(TCPflags),temp
ret
; ##############################################################################
MAKE_TCP_FLAG_FIN_ACK:
	ldi temp,(1<<TCPflag_FIN)|(1<<TCPflag_ACK)
	STS(TCPflags),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TX_FRAME_LENGTH fr ENC														
MAKE_ENC_TX_FRAME_LENGTH:
	LDS ZL,(IP4TotalLengthL)
	LDS ZH,(IP4TotalLengthH)
	adiw ZL,14	; +14 Bytes MAC-HEADER
	STS(adr_ENC_TX_FRAME_LENGTH_L),ZL
	STS(adr_ENC_TX_FRAME_LENGTH_H),ZH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MAKE_IP4_HEADER_CHECKSUM:
	STS(IP4HeaderChecksumL),NULL		; NULL				
	STS(IP4HeaderChecksumH),NULL
	ldi ZL,LOW (IP4_HEADER)				; Z-Zeiger-Data		
	ldi ZH,HIGH(IP4_HEADER)
	ldi XL,LOW (20)						; X-(Anzahl DATA)	
	ldi XH,HIGH(20)
	call FUNCTION_CHECKSUM_X_Z			; Berechnung		
	STS(IP4HeaderChecksumL),ZL			; Z-new Checksum	
	STS(IP4HeaderChecksumH),ZH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Der Pseudo-Header ist eine Zusammenstellung von Header-Teilen eines TCP-Segments 										
; und Teilen des Headers des einkapselnden IP-Pakets. 																	
; Es ist ein Modell, an dem sich die Berechnung der TCP-Prfsumme (engl. checksum) anschaulich beschreiben lsst.		
;Falls IP mit TCP eingesetzt wird, ist es wnschenswert, den Header des IP-Pakets mit in die Sicherung von TCP aufzunehmen. 
;Dadurch ist die Zuverlssigkeit seiner bertragung garantiert. 				
;Darum bildet man den IP-Pseudo-Header. 										
;Er besteht aus: IP-Absender und -Empfngeradresse, einem Null-Byte, einem Byte, das angibt zu welchem Protokoll 
;die Nutzdaten des IP-Pakets gehren und der Lnge des TCP-Segments mit TCP-Header. 
;Da es sich im Fall des Pseudo-Headers immer um IP-Pakete handelt, 				
;die TCP-Segmente transportieren, ist dieses Byte auf den Wert 6 gesetzt. 		
;Der Pseudo-Header wird fr die Berechnung der Prfsumme vor den TCP-Header gelegt. 
;Anschlieend berechnet man die Prfsumme. Die Summe wird im Feld checksum abgelegt und das Fragment versendet. 
;Kein Pseudo-Header wird je versendet. 											
;																				
; Pseudoheader basteln (IPv4)													
;-------------------------------------------------------------------------------
MAKE_TCP_PSEUDOHEADER_CHECKSUM:
	STS(TCPchecksumL),NULL				; NULL				
	STS(TCPchecksumH),NULL	
	clr YL								; CHECKSUM		
	clr YH
	; IP-Absenderadresse	
	LDS R1,(IP4SourceIPaddr3)
	LDS R0,(IP4SourceIPaddr2)
	rcall MAKE_TCP_PSEUDOHEADER_CHECKSUM_WORD
	LDS R1,(IP4SourceIPaddr1)
	LDS R0,(IP4SourceIPaddr0)
	rcall MAKE_TCP_PSEUDOHEADER_CHECKSUM_WORD
	; IP-Empfngeradresse
	LDS R1,(IP4DestinationIPaddr3)
	LDS R0,(IP4DestinationIPaddr2)
	rcall MAKE_TCP_PSEUDOHEADER_CHECKSUM_WORD
	LDS R1,(IP4DestinationIPaddr1)
	LDS R0,(IP4DestinationIPaddr0)
	rcall MAKE_TCP_PSEUDOHEADER_CHECKSUM_WORD
	; 0x0006 (=TCP) 	
	ldi temp2,HIGH(0x0006)
	ldi temp1,LOW (0x0006)
	mov R1,temp2
	mov R0,temp1
	rcall MAKE_TCP_PSEUDOHEADER_CHECKSUM_WORD
	; Lnge des TCP-Segments mit TCP-Header
	LDS XL,(IP4TotalLengthL)
	LDS XH,(IP4TotalLengthH)
	sbiw XL,20 					; -20(IPv4-Header)		
	mov R1,XH
	mov R0,XL
	rcall MAKE_TCP_PSEUDOHEADER_CHECKSUM_WORD
;-------------------------------------------------------------------------------
	; Schleife initialisieren			
	LDS XL,(IP4TotalLengthL)
	LDS XH,(IP4TotalLengthH)
	sbiw XL,20					; -20(IPv4-Header)		

	sbrc XL,0					; Schleife aufrunden ?	
	adiw XL,1					; +1					
	LSR XH						; Bytes--> Word			
	ROR XL
	ldi ZL,LOW (TCP_Header)	; Zeiger-Data		
	ldi ZH,HIGH(TCP_Header)
MAKE_TCP_PSEUDOHEADER_CHECKSUM_s:
	LD R1,Z+					; 16-bit word	
	LD R0,Z+
	rcall MAKE_TCP_PSEUDOHEADER_CHECKSUM_WORD
	sbiw XL,1					; Schleife		
	tst XL
	brne MAKE_TCP_PSEUDOHEADER_CHECKSUM_s
	tst XH
	brne MAKE_TCP_PSEUDOHEADER_CHECKSUM_s
	com	YL 						; invertieren	
	com	YH
	STS(TCPchecksumL),YL		; CHECKSUM		
	STS(TCPchecksumH),YH
ret
;-------------------------------------------------------------------------------
MAKE_TCP_PSEUDOHEADER_CHECKSUM_WORD:
	add YL,R0										; addieren		
	adc YH,R1
	brcc MAKE_TCP_PSEUDOHEADER_CHECKSUM_WORD_w	; Carry			
	add YL,EINS		
	adc YH,NULL
MAKE_TCP_PSEUDOHEADER_CHECKSUM_WORD_w:
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: 	X Anzahl Bytes															
;		Z Zeiger																
; OUT:	Z CHECKSUM																
FUNCTION_CHECKSUM_X_Z:
	sbrc XL,0					; Schleife aufrunden ?	
	adiw XL,1					; +1					
	LSR XH						; Bytes--> Word			
	ROR XL
	clr YL						; CHECKSUM		
	clr YH
FUNCTION_CHECKSUM16_s:
	LD R1,Z+					; 16-bit word	
	LD R0,Z+
	add YL,R0					; addieren		
	adc YH,R1
	brcc FUNCTION_CHECKSUM16_w	; Carry			
	add YL,EINS					; +1			
	adc YH,NULL
FUNCTION_CHECKSUM16_w:
	sbiw XL,1					; Schleife		
	tst XL
	brne FUNCTION_CHECKSUM16_s
	tst XH
	brne FUNCTION_CHECKSUM16_s
	com	YL 						; invertieren	
	com	YH
	mov ZL,YL					; KOPIE			
	mov ZH,YH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_TCP_RX_DATA_LENGTH:
	; TCP-HeaderLength				
	LDS  temp1,(TCPHeaderLength)
	swap temp1
	andi temp1,0b00001111
	ldi  temp,32			; mal 32
	mul temp,temp1
	LSR R0
	LSR R0
	LSR R0
	mov temp3,R0

	LDS ZL,(IP4TotalLengthL)
	LDS ZH,(IP4TotalLengthH)
	sub ZL,temp3
	sbc ZH,NULL
	sbiw ZL,20				; Z=Ergebnis
	STS(adr_TCP_RX_DATA_LENGTH_L),ZL
	STS(adr_TCP_RX_DATA_LENGTH_H),ZH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "favicon.ico"																	
FUNCTION_SEARCH_favicon_ICO_C:
	ldi ZL,LOW (TCPdata)
	ldi ZH,HIGH(TCPdata)
	ldi temp9,255
FUNCTION_SEARCH_favicon_ICO_C_S:
	dec temp9
	breq FUNCTION_SEARCH_FAVICON_ICO_C_NOT_FOUND
	LD temp,Z+
	cpi temp,'f'
	brne FUNCTION_SEARCH_favicon_ICO_C_S
	LD temp,Z+
	cpi temp,'a'
	brne FUNCTION_SEARCH_favicon_ICO_C_S
	LD temp,Z+
	cpi temp,'v'
	brne FUNCTION_SEARCH_favicon_ICO_C_S
	LD temp,Z+
	cpi temp,'i'
	brne FUNCTION_SEARCH_favicon_ICO_C_S
	LD temp,Z+
	cpi temp,'c'
	brne FUNCTION_SEARCH_favicon_ICO_C_S
	LD temp,Z+
	cpi temp,'o'
	brne FUNCTION_SEARCH_favicon_ICO_C_S
	LD temp,Z+
	cpi temp,'n'
	brne FUNCTION_SEARCH_favicon_ICO_C_S
FUNCTION_SEARCH_FAVICON_ICO_C_FOUND:
	SEC 			;Set Carry
	ret
FUNCTION_SEARCH_FAVICON_ICO_C_NOT_FOUND:
	CLC 			;Clear Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
