; ##############################################################################
; ##############################################################################
; ##############################################################################
HTML_WEBSEITE:
	ldi temp,(MODUL_HTML)					; MODUL		
	STS(adr_MODUL_NR),temp

	LDS temp1,(adr_TCP_RX_VIEW_IP4SourceIPaddr0)
	LDS temp2,(adr_TCP_RX_VIEW_IP4SourceIPaddr1)
	LDS temp3,(adr_TCP_RX_VIEW_IP4SourceIPaddr2)
	LDS temp4,(adr_TCP_RX_VIEW_IP4SourceIPaddr3)
	STS(adr_TCP_RX_VIEW_OK_IP4SourceIPaddr0),temp1
	STS(adr_TCP_RX_VIEW_OK_IP4SourceIPaddr1),temp2
	STS(adr_TCP_RX_VIEW_OK_IP4SourceIPaddr2),temp3
	STS(adr_TCP_RX_VIEW_OK_IP4SourceIPaddr3),temp4
;-------------------------------------------------------------------------------
HTML_WEB_A:
	LDS temp1,(adr_TCP_RX_VIEW_TCP_PORT_DEST_L)
	LDS temp2,(adr_TCP_RX_VIEW_TCP_PORT_DEST_H)
	LDS temp3,(adr_TCP_PORT_WEB_A_L)
	LDS temp4,(adr_TCP_PORT_WEB_A_H)
	cp temp1,temp3
	brne HTML_WEB_B
	cp temp2,temp4
	brne HTML_WEB_B
	call HTML_MAKE_RESPONSE_HEADER			; RESPONSE_HEADER	
	call HTML_MAKE_HEADER					; HEADER			
	call HTML_WEBSEITE_A 					; WEBSEITE-A		
	call HTML_MAKE_ENDE
	ret
;-------------------------------------------------------------------------------
HTML_WEB_B:
	LDS temp3,(adr_TCP_PORT_WEB_B_L)
	LDS temp4,(adr_TCP_PORT_WEB_B_H)
	cp temp1,temp3
	brne HTML_WEB_C
	cp temp2,temp4
	brne HTML_WEB_C
	call HTML_MAKE_RESPONSE_HEADER			; RESPONSE_HEADER	
	call HTML_MAKE_HEADER					; HEADER			
	call HTML_WEBSEITE_A 					; WEBSEITE-A		
	call HTML_WEBSEITE_B 					; WEBSEITE-B		
	call HTML_MAKE_ENDE
	ret
;-------------------------------------------------------------------------------
HTML_WEB_c:
	jmp HTML_WEBSEITE_C 					; WEBSEITE			
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: Y 	Zeiger																
HTML_MAKE_RESPONSE_HEADER:
	ldi YL,LOW (adr_TCP_STACK)					;(Y) Zeiger			
	ldi YH,HIGH(adr_TCP_STACK)
	ldi ZL,LOW (HTML_TABELLE_RESPONSE_HEADER*2)	; TABELLE			
	ldi ZH,HIGH(HTML_TABELLE_RESPONSE_HEADER*2)
	jmp HTML_TABELLE_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP/OUT: Y 	Zeiger															
HTML_MAKE_HEADER:
	ldi ZL,LOW (HTML_TABELLE_HEADER*2)	; TABELLE			
	ldi ZH,HIGH(HTML_TABELLE_HEADER*2)
	jmp HTML_TABELLE_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: Y 	Zeiger																
HTML_MAKE_ENDE:
	ldi ZL,LOW (HTML_TABELLE_ENDE*2)	; TABELLE			
	ldi ZH,HIGH(HTML_TABELLE_ENDE*2)
	call HTML_TABELLE_Z
	call HTML_MAKE_DATA_LENGTH			; HTML DATA_LENGTH				
	call HTML_MAKE_CONTENENT_LENGTH		; HTML CONTENENT_LENGTH			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: 	Y 	Zeiger																
;		Z   TABELLE																
HTML_TABELLE_Z:
	LPM temp, Z+   								; aus Tabelle Z+1	
	cpi temp,0xFF  								; ENDE ?			
	brne HTML_TABELLE_Z_w
	ret
HTML_TABELLE_Z_w:
	ST Y+,temp
	rjmp HTML_TABELLE_Z							; Schleife			
; ##############################################################################
; ##############################################################################
; ##############################################################################
HTML_MAKE_DATA_LENGTH:
	; nach "</html>" suchen				
	clr XL							;(X) Byte Zhler	
	clr XH
	ldi ZL,LOW (adr_TCP_STACK)			;(Z) Zeiger			
	ldi ZH,HIGH(adr_TCP_STACK)
HTML_MAKE_TCP_TX_DATA_LENGTH_s:
	LD temp,Z+
	adiw XL,1		;(X+1) Byte Zhler	
	cpi temp,'<'	; < 
	brne HTML_MAKE_TCP_TX_DATA_LENGTH_s
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'/'	; / 
	brne HTML_MAKE_TCP_TX_DATA_LENGTH_s
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'h'	; h 
	brne HTML_MAKE_TCP_TX_DATA_LENGTH_s
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'t'	; t 
	brne HTML_MAKE_TCP_TX_DATA_LENGTH_s
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'m'	; m 
	brne HTML_MAKE_TCP_TX_DATA_LENGTH_s
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'l'	; l 
	brne HTML_MAKE_TCP_TX_DATA_LENGTH_s
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'>'	; > 
	brne HTML_MAKE_TCP_TX_DATA_LENGTH_s
;-------------------------------------------------------------------------------
	ldi temp,13		; 13
	ST  Z+,temp
	adiw XL,1
	ldi temp,10		; 10
	ST  Z+,temp
	adiw XL,1
;-------------------------------------------------------------------------------
	ldi temp,'E'	; DUMMY
	ST  Z+,temp
	ldi temp,'E'	; DUMMY
	ST  Z+,temp
	ldi temp,'E'	; DUMMY
	ST  Z+,temp
	ldi temp,'E'	; DUMMY
	ST  Z+,temp
;-------------------------------------------------------------------------------
	; X(HTML_DATA_LENGTH) muss vermutlich gerade sein
	sbrc XL,0
	adiw XL,1
;-------------------------------------------------------------------------------
	STS(adr_HTML_DATA_LENGTH_L),XL		; DATA_LENGTH		
	STS(adr_HTML_DATA_LENGTH_H),XH
	STS(adr_TCP_STACK_LENGTH_L),XL		; TCP_STACK_LENGTH	
	STS(adr_TCP_STACK_LENGTH_H),XH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CONTENENT_LENGTH																
HTML_MAKE_CONTENENT_LENGTH:
	ldi ZL,LOW (adr_TCP_STACK)			;(Z) Zeiger			
	ldi ZH,HIGH(adr_TCP_STACK)
HTML_MAKE_CONTENENT_LENGTH_s1:
	; nach "<html>" suchen	
	clr XL							;(X) Byte Zhler	
	clr XH
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'<'	; < 
	brne HTML_MAKE_CONTENENT_LENGTH_s1	
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'h'	; h 
	brne HTML_MAKE_CONTENENT_LENGTH_s1
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'t'	; t 
	brne HTML_MAKE_CONTENENT_LENGTH_s1
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'m'	; m 
	brne HTML_MAKE_CONTENENT_LENGTH_s1
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'l'	; l 
	brne HTML_MAKE_CONTENENT_LENGTH_s1
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'>'	; > 
	brne HTML_MAKE_CONTENENT_LENGTH_s1
;-------------------------------------------------------------------------------
	; nach "</html>" suchen				
HTML_MAKE_CONTENENT_LENGTH_s2:
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'<'	; < 
	brne HTML_MAKE_CONTENENT_LENGTH_s2
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'/'	; / 
	brne HTML_MAKE_CONTENENT_LENGTH_s2
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'h'	; h 
	brne HTML_MAKE_CONTENENT_LENGTH_s2
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'t'	; t 
	brne HTML_MAKE_CONTENENT_LENGTH_s2
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'m'	; m 
	brne HTML_MAKE_CONTENENT_LENGTH_s2
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'l'	; l 
	brne HTML_MAKE_CONTENENT_LENGTH_s2
	LD temp,Z+
	adiw XL,1		; +1
	cpi temp,'>'	; > 
	brne HTML_MAKE_CONTENENT_LENGTH_s2
	; SAVE					
	STS(adr_HTML_CONTENENT_LENGTH_L),XL
	STS(adr_HTML_CONTENENT_LENGTH_H),XH
	mov temp1,XL
	mov temp2,XH
	clr temp3
	clr temp4
;-------------------------------------------------------------------------------
	; nach "xxxx" suchen				
	ldi ZL,LOW (adr_TCP_STACK)			;(Z) Zeiger			
	ldi ZH,HIGH(adr_TCP_STACK)
HTML_MAKE_CONTENENT_LENGTH_s3:
	LD temp,Z+
	cpi temp,'x'	; "x"
	brne HTML_MAKE_CONTENENT_LENGTH_s3
	LD temp,Z+
	cpi temp,'x'	; "x"
	brne HTML_MAKE_CONTENENT_LENGTH_s3
	LD temp,Z+
	cpi temp,'x'	; "x"
	brne HTML_MAKE_CONTENENT_LENGTH_s3
	LD temp,Z+
	cpi temp,'x'	; "x"
	brne HTML_MAKE_CONTENENT_LENGTH_s3
	sbiw ZL,4		; -4
;-------------------------------------------------------------------------------
	; ASCII								
	call FUNKTION_HEX_ASC_32
	ST Z+,temp4
	ST Z+,temp3
	ST Z+,temp2
	ST Z+,temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HTML_ZAHL_2_STELLEN_TEMP1:
	clr temp2
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32
	ST Y+,temp2
	ST Y+,temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; mit Nullstellenunterdrckung													
HTML_ZAHL_3_STELLEN_TEMP1:
	clr temp2
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32
	cpi temp3,'0'
	breq HTML_ZAHL_3_STELLEN_TEMP1_w1
	ST Y+,temp3
	ST Y+,temp2
	ST Y+,temp1
	ret
HTML_ZAHL_3_STELLEN_TEMP1_w1:
	cpi temp2,'0'
	breq HTML_ZAHL_3_STELLEN_TEMP1_w2
	ST Y+,temp2
	ST Y+,temp1
	ret
HTML_ZAHL_3_STELLEN_TEMP1_w2:
	ST Y+,temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OHNE Nullstellenunterdrckung													
HTML_ZAHL_3_STELLEN_FIX_TEMP1:
	clr temp2
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32
	ST Y+,temp3
	ST Y+,temp2
	ST Y+,temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HTML_ZAHL_3_STELLEN_NEGATIV_TEMP1:
	tst temp1
	brmi HTML_ZAHL_3_STELLEN_NEGATIV_TEMP1_n
	ldi temp,'+'
	ST Y+,temp
	jmp HTML_ZAHL_3_STELLEN_NEGATIV_TEMP1_w
HTML_ZAHL_3_STELLEN_NEGATIV_TEMP1_n:
	ldi temp,'-'
	ST Y+,temp
	com temp1
	inc temp1
HTML_ZAHL_3_STELLEN_NEGATIV_TEMP1_w:
	clr temp2
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32
	ST Y+,temp3
	ST Y+,temp2
	ST Y+,temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HTML_ZAHL_KOMMA_TEMP1:
	clr temp2
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32
	cpi temp3,'0'
	brne HTML_ZAHL_KOMMA_TEMP1_w
	ldi temp3,' '		; SPACE	
HTML_ZAHL_KOMMA_TEMP1_w:
	ST Y+,temp3
	ST Y+,temp2
	call HTML_PUNKT		; '.'
	ST Y+,temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; mit Nullstellenunterdrckung													
HTML_ZAHL_5_STELLEN_TEMP1_TEMP2:
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32
	cpi temp5,'0'					; Nullstellen-Unterdrckung	
	breq HTML_ZAHL_5_STELLEN_TEMP1_TEMP2_w1
	ST Y+,temp5
	ST Y+,temp4
	ST Y+,temp3
	ST Y+,temp2
	ST Y+,temp1
	ret
HTML_ZAHL_5_STELLEN_TEMP1_TEMP2_w1:
	cpi temp4,'0'					; Nullstellen-Unterdrckung	
	breq HTML_ZAHL_5_STELLEN_TEMP1_TEMP2_w2
	ST Y+,temp4
	ST Y+,temp3
	ST Y+,temp2
	ST Y+,temp1
	ret
HTML_ZAHL_5_STELLEN_TEMP1_TEMP2_w2:
	cpi temp3,'0'					; Nullstellen-Unterdrckung	
	breq HTML_ZAHL_5_STELLEN_TEMP1_TEMP2_w3
	ST Y+,temp3
	ST Y+,temp2
	ST Y+,temp1
	ret
HTML_ZAHL_5_STELLEN_TEMP1_TEMP2_w3:
	cpi temp2,'0'					; Nullstellen-Unterdrckung	
	breq HTML_ZAHL_5_STELLEN_TEMP1_TEMP2_w4
	ST Y+,temp2
	ST Y+,temp1
	ret
HTML_ZAHL_5_STELLEN_TEMP1_TEMP2_w4:
	ST Y+,temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "-1.2C"																	
HTML_TEMPERATUR_TEMP1_TEMP2:
	tst temp2				; positiv ?	
	brpl HTML_TEMPERATUR_TEMP1_TEMP2_RUN
;-------------------------------------------------------------------------------
HTML_TEMPERATUR_TEMP1_TEMP2_NEG:
	call HTML_MINUS			; '-'		
	com temp1
	com temp2
	add temp1,EINS
	adc temp2,NULL
;-------------------------------------------------------------------------------
HTML_TEMPERATUR_TEMP1_TEMP2_RUN:
	clr temp3
	clr temp4
	call FUNKTION_HEX_ASC_32

	cpi temp5,'0'
	brne HTML_TEMPERATUR_TEMP1_TEMP2_ACTION
	ldi temp5,' '		; SPACE	

	cpi temp4,'0'
	brne HTML_TEMPERATUR_TEMP1_TEMP2_ACTION
	ldi temp4,' '		; SPACE	

	cpi temp3,'0'
	brne HTML_TEMPERATUR_TEMP1_TEMP2_ACTION
	ldi temp3,' '		; SPACE	
HTML_TEMPERATUR_TEMP1_TEMP2_ACTION:
	ST Y+,temp5
	ST Y+,temp4
	ST Y+,temp3
	ST Y+,temp2
	call HTML_PUNKT		; '.'
	ST Y+,temp1
	call HTML_GRD		; ''
	call HTML_C			; 'C'
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HTML_HEX8_TEMP1:
	; SICHERUNGSKOPIE						
	push temp
	push temp1
	; oberes NIBBLE bearbeiten				
	mov temp,temp1	
	swap temp					; NIBBLES tausch	
	call HTML_HEX8_UMWANDLUNG	; INP/OUT: temp		
	ST Y+,temp					; AUSGABE			
	; unteres NIBBLE bearbeiten				
	mov temp,temp1	
	call HTML_HEX8_UMWANDLUNG	; INP/OUT: temp		
	ST Y+,temp					; AUSGABE			
	; SICHERUNGSKOPIE wieder herstellen		
	pop temp1
	pop temp
	ret
;-------------------------------------------------------------------------------
HTML_HEX8_UMWANDLUNG:
	andi temp,0b00001111	; BITMUSTER	

	cpi temp,10				; vergleich	
	brsh HTML_HEX8_UMWANDLUNG_A_F
HTML_HEX8_UMWANDLUNG_0_9:
	subi temp,-48
	ret
HTML_HEX8_UMWANDLUNG_A_F:
	subi temp,-48-7
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HTML_FARBE_ROT:
	push ZL
	push ZH
	ldi ZL,LOW (HTML_TABELLE_FARBE_ROT*2)	; Tabelle	
	ldi ZH,HIGH(HTML_TABELLE_FARBE_ROT*2)
	call HTML_TABELLE_Z
	pop ZH
	pop ZL
ret
;-------------------------------------------------------------------------------
HTML_FARBE_GRUEN:
	push ZL
	push ZH
	ldi ZL,LOW (HTML_TABELLE_FARBE_GRUEN*2)	; Tabelle	
	ldi ZH,HIGH(HTML_TABELLE_FARBE_GRUEN*2)
	call HTML_TABELLE_Z
	pop ZH
	pop ZL
ret
;-------------------------------------------------------------------------------
HTML_FARBE_BLAU:
	push ZL
	push ZH
	ldi ZL,LOW (HTML_TABELLE_FARBE_BLAU*2)	; Tabelle	
	ldi ZH,HIGH(HTML_TABELLE_FARBE_BLAU*2)
	call HTML_TABELLE_Z
	pop ZH
	pop ZL
ret	
;-------------------------------------------------------------------------------
HTML_FARBE_SCHWARZ:
	push ZL
	push ZH
	ldi ZL,LOW (HTML_TABELLE_FARBE_SCHWARZ*2)	; Tabelle	
	ldi ZH,HIGH(HTML_TABELLE_FARBE_SCHWARZ*2)
	call HTML_TABELLE_Z
	pop ZH
	pop ZL
ret
;-------------------------------------------------------------------------------
HTML_FARBE_GRAU:
	push ZL
	push ZH
	ldi ZL,LOW (HTML_TABELLE_FARBE_GRAU*2)	; Tabelle	
	ldi ZH,HIGH(HTML_TABELLE_FARBE_GRAU*2)
	call HTML_TABELLE_Z
	pop ZH
	pop ZL
ret
;-------------------------------------------------------------------------------
HTML_FONT_SIZE_6:
	push ZL
	push ZH
	ldi ZL,LOW (HTML_TABELLE_FONT_SIZE_6*2)	; Tabelle	
	ldi ZH,HIGH(HTML_TABELLE_FONT_SIZE_6*2)
	call HTML_TABELLE_Z
	pop ZH
	pop ZL
ret
;-------------------------------------------------------------------------------
; "<br>"																		
HTML_NEW_ZEILE:
	call HTML_KLEINER
	call HTML_b_
	call HTML_r_
	call HTML_GROESSER
ret
;-------------------------------------------------------------------------------
; <hr>																			
HTML_LINIE:
	call HTML_KLEINER
	call HTML_h_
	call HTML_r_
	call HTML_GROESSER
ret
;-------------------------------------------------------------------------------
HTML_Y_TEMP:
	ST Y+,temp
	ret
;-------------------------------------------------------------------------------
; http://www.html-seminar.de/referenz-sonderzeichen.htm							
HTML_SPACE:
	ldi temp,' '
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_PUNKT:
	ldi temp,'.'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_DOPPEL_PUNKT:
	ldi temp,':'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_GRD:
	ldi temp,''
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_MINUS:
	ldi temp,'-'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_KLEINER:
	ldi temp,'<'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_GROESSER:
	ldi temp,'>'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_PROZENT:
	ldi temp,'%'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_UNTERSTRICH:
	ldi temp,'_'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_KLAMMER_AUF:
	ldi temp,'('
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_KLAMMER_ZU:
	ldi temp,')'
	jmp HTML_Y_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
HTML_0:
	ldi temp,'0'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_1:
	ldi temp,'1'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_2:
	ldi temp,'2'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_3:
	ldi temp,'3'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_4:
	ldi temp,'4'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_5:
	ldi temp,'5'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_6:
	ldi temp,'6'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_7:
	ldi temp,'7'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_8:
	ldi temp,'8'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_9:
	ldi temp,'9'
	jmp HTML_Y_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
HTML_A:
	ldi temp,'A'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_B:
	ldi temp,'B'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_C:
	ldi temp,'C'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_D:
	ldi temp,'D'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_E:
	ldi temp,'E'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_F:
	ldi temp,'F'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_G:
	ldi temp,'G'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_H:
	ldi temp,'H'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_I:
	ldi temp,'I'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_J:
	ldi temp,'J'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_K:
	ldi temp,'K'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_L:
	ldi temp,'L'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_M:
	ldi temp,'M'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_N:
	ldi temp,'N'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_O:
	ldi temp,'O'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_P:
	ldi temp,'P'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_Q:
	ldi temp,'Q'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_R:
	ldi temp,'R'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_S:
	ldi temp,'S'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_T:
	ldi temp,'T'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_U:
	ldi temp,'U'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_V:
	ldi temp,'V'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_W:
	ldi temp,'W'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_X:
	ldi temp,'X'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_Y:
	ldi temp,'Y'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_Z:
	ldi temp,'Z'
	jmp HTML_Y_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
HTML_a_:
	ldi temp,'a'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_ae_:
	ldi temp,''
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_B_:
	ldi temp,'b'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_C_:
	ldi temp,'c'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_D_:
	ldi temp,'d'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_E_:
	ldi temp,'e'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_F_:
	ldi temp,'f'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_G_:
	ldi temp,'g'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_H_:
	ldi temp,'h'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_I_:
	ldi temp,'i'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_J_:
	ldi temp,'j'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_K_:
	ldi temp,'k'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_L_:
	ldi temp,'l'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_M_:
	ldi temp,'m'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_N_:
	ldi temp,'n'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_O_:
	ldi temp,'o'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_P_:
	ldi temp,'p'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_Q_:
	ldi temp,'q'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_R_:
	ldi temp,'r'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_S_:
	ldi temp,'s'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_T_:
	ldi temp,'t'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_U_:
	ldi temp,'u'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_V_:
	ldi temp,'v'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_W_:
	ldi temp,'w'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_X_:
	ldi temp,'x'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_Y_:
	ldi temp,'y'
	jmp HTML_Y_TEMP
;-------------------------------------------------------------------------------
HTML_Z_:
	ldi temp,'z'
	jmp HTML_Y_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
HTML_TABELLE_RESPONSE_HEADER:
.db "HTTP/1.1 200 OK "			,13,10
.db "Content-Length: xxxx"		,13,10								; "xxxx" wird spter korrigiert	
.db "Cache-Control: no-cache "	,13,10
.db "Content-Type: text/html "	,13,10
.db "Connection: Closed"		,13,10
.db 13,10, $FF,$FF													; Leerzeile !!!					
;-------------------------------------------------------------------------------
HTML_TABELLE_HEADER:
.db "<html>"
.db "<head><title>Webserver-2019 V2</TITLE></HEAD> "						; TITEL			
.db "<BODY BGCOLOR='#ffffff'>"										; Hintergrund	
.db "<FONT FACE='Arial' SIZE=10 COLOR='#800080'>",$FF				; Font			
.db $FF,$FF	
;-------------------------------------------------------------------------------
HTML_TABELLE_ENDE:
.db "</font></body></html>",$FF									; ENDE (Tabelle)
;-------------------------------------------------------------------------------
; http://www.htmlbasis.de/websprachen/html/html-kurs/farbendarstellung.html		
; http://html-color-codes.info/webfarben_hexcodes/								
HTML_TABELLE_FARBE_ROT:
.db "<FONT FACE COLOR='#CC0000'>",$FF				; Font			
HTML_TABELLE_FARBE_GRUEN:
.db "<FONT FACE COLOR='#008000'>",$FF				; Font			
HTML_TABELLE_FARBE_BLAU:
.db "<FONT FACE COLOR='#0000ff'>",$FF				; Font			
HTML_TABELLE_FARBE_SCHWARZ:
.db "<FONT FACE COLOR='#000000'>",$FF				; Font			
HTML_TABELLE_FARBE_GRAU:
.db "<FONT FACE COLOR='#808080'>",$FF				; Font			
;-------------------------------------------------------------------------------
HTML_TABELLE_FONT_SIZE_6:
.db "<FONT SIZE=6>",$FF


